
-- Frame Events {{{
function AIOIFrame_OnEvent(event)
   if ( event == "VARIABLES_LOADED" ) then
      AIOI_Setup_Hooks(1);
      AIOI_DEBUG("Variables Loaded...");
      AIOI_Loaded = true;
      AIOI_MyAddonsRegister();
      AIOI_InitializeProfile();
      this:UnregisterEvent(event);
      this:RegisterEvent("PLAYER_ENTERING_WORLD")
      this:RegisterEvent("PLAYER_LEAVING_WORLD")
   end
   if not AIOI_Loaded then
      return
   end
   --if ( event == "UNIT_NAME_UPDATE" and arg1 == "player" and UnitName("player") ~= UNKNOWNOBJECT) then
      --AIOI_InitializeProfile();
   --end
   if PlayerName == nil then
      return
   end

   if event == "PLAYER_LEAVING_WORLD" then
      this:UnregisterEvent("BAG_UPDATE");
      this:UnregisterEvent("BAG_UPDATE_COOLDOWN");
      this:UnregisterEvent("ITEM_LOCK_CHANGED");
      this:UnregisterEvent("UPDATE_INVENTORY_ALERTS");
   elseif event == "PLAYER_ENTERING_WORLD" then
      this:RegisterEvent("BAG_UPDATE");
      this:RegisterEvent("BAG_UPDATE_COOLDOWN");
      this:RegisterEvent("ITEM_LOCK_CHANGED");
      this:RegisterEvent("UPDATE_INVENTORY_ALERTS");
   elseif ( event == "BAG_UPDATE" ) then
      if ( this:IsVisible() ) then
         AIOI_DEBUG("BAG_UPDATE Event fired.");
         AIOIFrame_Update(AIOIFrame);
      end
   elseif ( event == "ITEM_LOCK_CHANGED" or event == "BAG_UPDATE_COOLDOWN" or event == "UPDATE_INVENTORY_ALERTS" ) then
      if ( this:IsVisible() ) then
         AIOIFrame_Update(AIOIFrame);
      end
   elseif (event == "MERCHANT_SHOW" or event == "AUCTION_HOUSE_SHOW" or event == "MAIL_SHOW" or event == "TRADE_SHOW" or event == "BANKFRAME_OPENED") then
      if (AIOIReplaceBags == 1) then
         OpenAIOIFrame();
      end;
   elseif (event == "MERCHANT_CLOSED" or event == "AUCTION_HOUSE_CLOSED" or event == "MAIL_CLOSED" or event == "TRADE_CLOSED" or event == "BANKFRAME_CLOSED") then
      if (AIOIReplaceBags == 1 and AIOIFreeze == 0) then
         CloseAIOIFrame();
      end;
   end
end

function AIOIFrame_OnHide()
   PlaySound("igBackPackClose");
   AIOI_UpdateBagState();
end

function AIOIFrame_OnShow()
   if AIOI_Initialized == false then
      AIOIFrame:Hide();
      return;
   end
   AIOIFrame_Update(AIOIFrame);
   PlaySound("igBackPackOpen");
   AIOIFrame:ClearAllPoints();
   AIOIFrame:SetPoint("BOTTOMRIGHT", "AIOIAnchorFrame", "BOTTOMRIGHT");
   local pScale = AIOIFrame:GetParent():GetScale();
   if ( not pScale ) then pScale = 1; end
   if AIOIFrame:GetScale() ~= pScale * tonumber(AIOIScale) then
      AIOIFrame:SetScale(AIOIScale);
   end
end

function AIOIFrame_OnMouseDown(arg1)
   if ( arg1 == "LeftButton" ) then
      if ( AIOILock == 0 ) then
         -- this:StartMoving();
         AIOIAnchorFrame:StartMoving();
      else
         AIOI_Print("AIOI is locked and can not move...");
      end
   end
end

function AIOIFrame_OnMouseUp(arg1)
   if ( arg1 == "LeftButton" ) then
      this:StopMovingOrSizing();
      AIOIAnchorFrame:StopMovingOrSizing();
   end
end
-- }}}

-- Item Button Events {{{
function AIOIFrameItemButton_OnLoad()
   this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
   this:RegisterForDrag("LeftButton");
   this:RegisterEvent("CURSOR_UPDATE");
   this:RegisterEvent("BAG_UPDATE_COOLDOWN");

   this.SplitStack = function(button, split)
      SplitContainerItem(button:GetParent():GetID(), button:GetID(), split);
   end
end

-- DressingRoom code here
function AIOIFrameItemButton_OnClick(button, ignoreShift)
   local bag, slot = this.bagIndex, this.itemIndex;
   local link = GetContainerItemLink(bag,slot)

   -- to make component work...
   if not ignoreShift and Comp_TestOnClick and Comp_TestOnClick(button) then
      if Comp_OnClick(button, link) then return end
    end

   if ( button == "LeftButton" ) then
      if ( IsShiftKeyDown() and not ignoreShift ) then
         if ( ChatFrameEditBox:IsVisible() ) then
            ChatFrameEditBox:Insert(link);
         else
            local texture, itemCount, locked = GetContainerItemInfo(bag, slot);
            if ( not locked ) then
               this.SplitStack = function(button, split)
                  SplitContainerItem(bag, slot, split);
               end
               OpenStackSplitFrame(this.count, this, "BOTTOMRIGHT", "TOPRIGHT");
            end
         end
      elseif ( IsControlKeyDown() ) then
         DressUpItemLink(link);
      else
         PickupContainerItem(bag, slot);
      end
   elseif ( button == "RightButton" ) then
      if ( IsShiftKeyDown() and MerchantFrame:IsVisible() and not ignoreShift ) then
         this.SplitStack = function(button, split)
            SplitContainerItem(button:GetParent():GetID(), button:GetID(), split);
            MerchantItemButton_OnClick("LeftButton");
         end
         OpenStackSplitFrame(this.count, this, "BOTTOMRIGHT", "TOPRIGHT");
      elseif ( MerchantFrame:IsVisible() and MerchantFrame.selectedTab == 2 ) then
         -- Don't sell the item if the buyback tab is selected
         return;
      else
         UseContainerItem(bag, slot);
         StackSplitFrame:Hide();
      end
   end
end

function AIOIFrameItemButton_OnEnter()
   local bag, slot = this.bagIndex, this.itemIndex;
   this:GetParent():SetID(this.bagIndex);
   this:SetID(this.itemIndex);
   ContainerFrameItemButton_OnEnter()
   AIOI_HighlightItemBag(bag);

   if true then
      return
   end

   --  Mimiking: ContainerFrameItemButton_OnEnter() - BEGIN
   GameTooltip:SetOwner(this, "ANCHOR_LEFT");
   local hasCooldown, repairCost = GameTooltip:SetBagItem(bag, slot);
   if ( hasCooldown ) then
      this.updateTooltip = TOOLTIP_UPDATE_TIME;
   else
      this.updateTooltip = nil;
   end
   if ( InRepairMode() and (repairCost and repairCost > 0) ) then
      GameTooltip:AddLine(TEXT(REPAIR_COST), "", 1, 1, 1);
      SetTooltipMoney(GameTooltip, repairCost);
      GameTooltip:Show();
   elseif ( MerchantFrame:IsVisible() ) then
      ShowContainerSellCursor(bag, slot);
   elseif ( this.readable ) then
      ShowInspectCursor();
   end
   --  Mimiking: ContainerFrameItemButton_OnEnter() - END

end

function AIOIFrameItemButton_OnLeave()
   AIOI_HighlightItemBag(this.bagIndex, 1);
   this.updateTooltip = nil;
   GameTooltip:Hide();
   ResetCursor();
end

function AIOIFrameItemButton_OnUpdate(elapsed)
   if ( not this.updateTooltip ) then
      return;
   end

   this.updateTooltip = this.updateTooltip - elapsed;
   if ( this.updateTooltip > 0 ) then
      return;
   end

   if ( GameTooltip:IsOwned(this) ) then
      AIOIFrameItemButton_OnEnter();
   else
      this.updateTooltip = nil;
   end
end
-- }}}

-- Bag Button Events {{{
function AIOI_Backpack_OnEnter()
   GameTooltip:SetOwner(this,"ANCHOR_LEFT");
   GameTooltip:SetText(TEXT(BACKPACK_TOOLTIP),1.0,1.0,1.0);
   local keyBinding = GetBindingKey("TOGGLEBACKPACK");
   if ( keyBinding ) then
     GameTooltip:AppendText(" "..NORMAL_FONT_COLOR_CODE.."("..keyBinding..")"..FONT_COLOR_CODE_CLOSE);
   end
   AIOI_HighlightBagItems(0);
end

function AIOI_Backpack_OnLeave()
   GameTooltip:Hide();
   AIOI_HighlightBagItems(0,1);
end

function AIOI_BagButton_OnEnter()
   GameTooltip:SetOwner(this,"ANCHOR_RIGHT");
   local hasCooldown, repairCost = GameTooltip:SetInventoryItem("player", this:GetID());
   AIOI_HighlightBagItems(1+this:GetID()- AIOI_____Bag0Slot:GetID());
end

function AIOI_BagButton_OnLeave()
   this.updateTooltip = nil;
   GameTooltip:Hide();
   ResetCursor();
   local bagID = 1+this:GetID()-AIOI_____Bag0Slot:GetID();
   AIOI_HighlightBagItems(bagID, 1);
end

function AIOI_BagButton_OnClick()
   local index = tonumber(strsub(this:GetName(), 13, 13))+2;
   local val = strsub(AIOIBags, index, index);
   if not PutItemInBag(this:GetID()) then
      local bagID = 1+this:GetID()-AIOI_____Bag0Slot:GetID();
      AIOI_HighlightBagItems(bagID, 1);
      if val == "1" then
         val = "0"
      else
         val = "1"
      end
      AIOIBags = strsub(AIOIBags, 1, index-1)..val..strsub(AIOIBags, index+1);
      AIOI_Toggle_Option("Bags", AIOIBags);
      AIOI_UpdateBagState();
      AIOIFrame_UpdateLook();
      AIOIFrame_Update();
   end
end
function AIOI_Backpack_OnClick()
   local val = strsub(AIOIBags, 1, 1);
   if not PutItemInBackpack() then
      AIOI_HighlightBagItems(0,1);
      if val == "1" then
         val = "0"
      else
         val = "1"
      end
      AIOIBags = val..strsub(AIOIBags, 2);
      AIOI_UpdateBagState();
      AIOIFrame_UpdateLook();
      AIOIFrame_Update();
      AIOI_Toggle_Option("Bags", AIOIBags);
   end
end
function AIOI_BagButton_OnDragStart()
   --BagSlotButton_OnDrag();
   PickupBagFromSlot(this:GetID());
   PlaySound("BAGMENUBUTTONPRESS");
end
function AIOI_BagButton_OnReceiveDrag()
   PutItemInBag(this:GetID());
end
-- }}}
