function AIOI_DEBUG(msg)
   -- If Debug is not set, just skip it.
   if ( not AIOIDEBUG or AIOIDEBUG == 0 ) then
      return;
   end

   msg = "*** DEBUG(AIOI): "..msg;
   if ( DEFAULT_CHAT_FRAME ) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1.0, 1.0, 0.0);
   end
end

-- Text related functions.
function AIOI_Trim (s)
   return (string.gsub(s, "^%s*(.-)%s*$", "%1"));
end

function AIOI_Print(msg,r,g,b,frame,id,unknown4th)
   --if ( Print ) then
   --	Print(msg, r, g, b, frame, id, unknown4th);
   --	return;
   --end
   if(unknown4th) then
      local temp = id;
      id = unknown4th;
      unknown4th = id;
   end

   if (not r) then r = 1.0; end
   if (not g) then g = 1.0; end
   if (not b) then b = 1.0; end
   if not frame then
      if DEFAULT_CHAT_FRAME then
         frame = DEFAULT_CHAT_FRAME
      else
         AIOI_DEBUG("quitting print");
         return
      end
   end
   if type(msg) == "table" then
      for key, value in pairs(msg) do
         frame:AddMessage(value, r, g, b,id,unknown4th);
      end
   else
      frame:AddMessage(msg, r, g, b,id,unknown4th);
   end
end

function AIOI_UpdateBorder(itemButton, itemQuality, bag)
   local color = {
      ["r"]=0.5,
      ["g"]=0.5,
      ["b"]=0.5 };

   if ( itemQuality ) then
      if itemQuality == -1 then
         color = {
            ["r"]=1,
            ["g"]=1,
            ["b"]=1 } -- white
      elseif itemQuality == 1 then
         color = {
            ["r"]=0.5,
            ["g"]=0.5,
            ["b"]=0.5 } -- grey
      elseif itemQuality == 2 then
         color = {
            ["r"]=0.0,
            ["g"]=1.0,
            ["b"]=0.0 } -- green
      elseif itemQuality == 3 then
         color = {
            ["r"]=0.5,
            ["g"]=0.5,
            ["b"]=1.0 } --  blue

      elseif itemQuality == 4 then
         color = {
            ["r"]=0.7,
            ["g"]=0.1,
            ["b"]=1.0 } -- purple
      else
         color = {
            ["r"]=0.0,
            ["g"]=0.0,
            ["b"]=0.0 }  -- black
      end
   end

   --modify bag colors...
   if bag and GetBagName(bag) then
      local bagName = GetBagName(bag)
      -- If it is a Quiver/AmmoBag, etc.
      if ( string.find(bagName, "Quiver") or string.find(bagName, "Ammo")
         or string.find(bagName, "Shot")  or string.find(bagName, "Bandolier")) then
         color = {
            ["r"]=1.0,
            ["g"]=1.0,
            ["b"]=0.0 }
      elseif (string.find(bagName, "Soul") or string.find(bagName, "Felcloth")) then
         color = {
            ["r"]=1.0,
            ["g"]=0.0,
            ["b"]=0.0 }
      elseif (string.find(bagName, "Herb")) then
         color = {
            ["r"]=0.0,
            ["g"]=1.0,
            ["b"]=0.0 }
      elseif (string.find(bagName, "Mine")) then
         color = {
            ["r"]=0.0,
            ["g"]=1.0,
            ["b"]=1.0 }
      elseif (string.find(bagName, "Enchanted")) then
         color = {
            ["r"]=0.0,
            ["g"]=0.0,
            ["b"]=1.0 }
      end
   end
   SetItemButtonNormalTextureVertexColor(itemButton, color.r, color.g, color.b);
end

function AIOI_Extract_NextParameter(msg) --
   local params = msg;
   local command = params;
   local index = strfind(command, " ");
   if ( index ) then
      command = strsub(command, 1, index-1);
      params = strsub(params, index+1);
   else
      params = "";
   end
   return command, params;
end
